--Functions for ZSokoban

function Start_Menu()
	if SndEna and Music:playing() then Music:pause() end
	sel=0
	local cc=color.yellow
	buttons.interval(20,20)
	while true do
		buttons.read()

		if bkg then bkg:blittint(0,0,cc) end
		player:blitsprite(160,60+sel,0)

		screen.print(200,80, "Easy", 1,ctext,cback)--sel=0
		screen.print(200,120, "Hard", 1,ctext,cback)--sel=40
		screen.print(200,160, "Load", 1,ctext,cback)--sel=80

		if buttons.down then sel+=40 end
		if buttons.up then sel-=40 end

		if sel==0 or sel==80 then cc=color.yellow end
		if sel==40 then cc=color.red end

		if sel>80 then sel=0 end
		if sel<0 then sel=80 end

		if buttons.cross then
			if sel<80 then
				if sel==0 then levels.mode,ch=0,1 else levels.mode,ch=1,30 end
				levels.reset,levels.life=0,3
				End_Level:play(1)
				while files.exists("ms0:/PSP/SAVEDATA/ZSOKOBAN".."000"..levels.slots) do levels.slots+=1 end
				if levels.slots>9 then levels.slots=9 end
				if SndEna and Music then Music:play(2) end
				Load_level()
				return 0
			elseif sel==80 then
				if Save_Load(false)==1 then
					flag = false
					if SndEna and Music then Music:play(2) end
					Load_level()
					return 0
				end
			end
		end

		if buttons.start then os.exit() end

		screen.print(5,260, "Press START for exit",0.8,ctext,cback)
		screen.flip()
	end
end

function Load_level()
	if map_level then map_level=nil end
	os.delay(100)

	num_moves=0									---Reset

	if levels.mode==0 then	limit=75*1000 else limit=95*1000 end

	map_level = map.new(tmp_tiles, gamefield[ch], w, h)--Load new map
	Pos_Player()

	if (ch==33) then limit=125*1000
	elseif (ch>10 and ch<20) then limit-=5*1000
	elseif (ch>=20 and ch<30) then limit-=10*1000
	elseif (ch>=30 and ch<#gamefield) then limit-=15*1000 end

	if cont then cont:reset() cont:start() end
end

function Pos_Player()
	sizeX=map_level:sizex()
	sizeY=map_level:sizey()

	for i=1,sizeY do
		for z=1,sizeX do
			if (map_level:tile(z,i)==1) then	--Tile 1 Player
				row=z
				col=i
				y=(i-1)*h--This
				if (sizeX*32<=480) then x=(z-1)*w--This
				else
					if (row<=9) then
						x=(z-1)*w--This
						map_X=0
					elseif (row>9 and row<=24)then
						map_X=(row-9)*32
						x=((row-1)*w)-map_X
					elseif (row>24 and row<=sizeX)then
						map_X=(30*w)/2
						x=480-(((sizeX-row)+1)*w)
					end
				end
				return 1
			end
		end
	end
	return 0
end

--[[
0 = black space
1 = position initial player
2 = goal
3 = block
4 = box blue
5 = box green
]]
function Check_Moves()
	buttons.interval(13,15)
	if buttons.down then
		frame=2
		if (map_level:tile(row,col+1)<3 or map_level:tile(row,col+1)==10)then			--Not Solids
			y+=h
			col+=1
			num_moves+=1
			
		elseif(map_level:tile(row,col+1)==4) then		--blue box
			if(map_level:tile(row,col+2)<2)then			--black space and pos initial
				col+=1
				map_level:tile(row,col+1,4)
				map_level:tile(row,col,0)
				y+=h
				num_moves+=1
				Drag:play(1)---
			elseif(map_level:tile(row,col+2)==2) then	--goal
				col+=1
				map_level:tile(row,col+1,5)
				Box_In_Place:play(1)--
				map_level:tile(row,col,0)
				y+=h
				num_moves+=1
			end
		elseif(map_level:tile(row,col+1)==5) then		--green box
			if (map_level:tile(row,col+2)<3) then
				col+=1
				if (map_level:tile(row,col+1) ~= 2) then
					map_level:tile(row,col+1,4)
					Drag:play(1)---
				else
					map_level:tile(row,col+1,5)
					Box_In_Place:play(1)--
				end
				map_level:tile(row,col,2)
				y+=h
				num_moves+=1
			end
		elseif (map_level:tile(row,col+1)==6) and levels.key!=1 then
			col+=1

			for i=1,sizeY do
				for z=1,sizeX do
					if (map_level:tile(z,i)==8) then map_level:tile(z,i,9) end
					if (map_level:tile(z,i)==10) then map_level:tile(z,i,7) end
					if (map_level:tile(z,i)==6) then map_level:tile(z,i,11) end
				end
			end

			col+=1
			y+=(2*h)
			num_moves+=1
			
		elseif (map_level:tile(row,col+1)==7) then
			col+=1
			map_level:tile(row,col,10)
			y+=h
			num_moves+=1
			levels.key=1
			if End_Level then End_Level:play(1) end
		end
	end--down

	if buttons.up then
		frame=6
		if (map_level:tile(row,col-1)<3) or map_level:tile(row,col-1)==10 then
			y-=h
			col-=1
			num_moves+=1
			

		elseif(map_level:tile(row,col-1)==4) then
			if(map_level:tile(row,col-2)<2)then
				col-=1
				map_level:tile(row,col-1,4)
				map_level:tile(row,col,0)
				y-=h
				num_moves+=1
				Drag:play(1)---
			elseif(map_level:tile(row,col-2)==2) then
				col-=1
				map_level:tile(row,col-1,5)
				Box_In_Place:play(1)--
				map_level:tile(row,col,0)
				y-=h
				num_moves+=1
			end
		elseif(map_level:tile(row,col-1)==5) then
			if (map_level:tile(row,col-2)<3) then
				col-=1
				if (map_level:tile(row,col-1) ~= 2) then
					map_level:tile(row,col-1,4)
					Drag:play(1)---
				else
					map_level:tile(row,col-1,5)
					Box_In_Place:play(1)--
				end 
				map_level:tile(row,col,2)
				y-=h
				num_moves+=1
			end
		elseif (map_level:tile(row,col-1)==11) then
			y-=(2*h)
			col-=2

			for i=1,sizeY do
				for z=1,sizeX do
					if (map_level:tile(z,i)==9) then map_level:tile(z,i,8) end
					if (map_level:tile(z,i)==11) then map_level:tile(z,i,6) end
					if (levels.key==0)then
						if (map_level:tile(z,i)==7) then map_level:tile(z,i,10) end
					end
				end
			end
			num_moves+=1
		end
	end--up

		function right_left(value,sum,val)
			row+=sum
			if (value==0) then x+=val else map_X+=val end
			num_moves+=1
			
		end
		function right_left2(value,sum,val)
			row+=sum
			if (value==0) then x+=val else map_X+=val end
			map_level:tile(row+sum,col,4)
			map_level:tile(row,col,0)
			num_moves+=1
			Drag:play(1)
		end
		function right_left3(value,sum,val)
			row+=sum
			map_level:tile(row+sum,col,5)
			Box_In_Place:play(1)--
			map_level:tile(row,col,0)
			if (value==0) then x+=val else map_X+=val end
			num_moves+=1
		end
		function right_left4(value,sum,val)
			row+=sum
			if (map_level:tile(row+sum,col) ~= 2) then
				map_level:tile(row+sum,col,4)
				Drag:play(1)---
			else
				map_level:tile(row+sum,col,5)
				Box_In_Place:play(1)--
			end
			map_level:tile(row,col,2)
			if (value==0) then x+=val else map_X+=val end
			num_moves+=1
		end

	if buttons.left then
		frame=5
		if (map_level:tile(row-1,col)<3) then
			if (sizeX*32<=480) then right_left(0,-1,-32)
			else
				if row > 1 then
					if (row>9 and row<=24)then
						right_left(1,-1,-32)
					elseif (row>23 or row<=9)then
						right_left(0,-1,-32)
					end
				end
			end
	
		elseif(map_level:tile(row-1,col)==4) then--box blue
			if (map_level:tile(row-2,col)<2) then
				if (sizeX*32<=480) then right_left2(0,-1,-32)
				else
					if row > 1 then
						if (row>9 and row<=24)then right_left2(1,-1,-32)
						elseif (row>23 or row<=9)then right_left2(0,-1,-32)end
					end
				end
	
			elseif(map_level:tile(row-2,col)==2) then
				if (sizeX*32<=480) then right_left3(0,-1,-32)
				else
					if row > 1 then
						if (row>9 and row<=24)then right_left3(1,-1,-32)
						elseif (row>23 or row<=9)then right_left3(0,-1,-32)end
					end
				end
			end

		elseif(map_level:tile(row-1,col)==5) then
			if (map_level:tile(row-2,col)<3) then
				if (sizeX*32<=480) then right_left4(0,-1,-32)
				else
					if row > 1 then
						if (row>9 and row<=24)then right_left4(0,-1,-32)
						elseif (row>23 or row<=9)then right_left4(0,-1,-32)end
					end
				end
			end
		end
	end--left

	if buttons.right then
		frame=0
		if (map_level:tile(row+1,col)<3) then
			if (sizeX*32<=480) then right_left(0,1,32)
			else
				if row <= sizeX then
					if (row<9 or row>=24)then right_left(0,1,32)
					elseif (row>8 and row<24)then right_left(1,1,32)end
				end
			end

		elseif(map_level:tile(row+1,col)==4) then
			if (map_level:tile(row+2,col)<2) then
				if (sizeX*32<=480) then right_left2(0,1,32)
				else
					if row <= sizeX then
						if (row<9 or row>=24)then right_left2(0,1,32)
						elseif (row>8 and row<24)then right_left2(1,1,32)end
					end
				end			

			elseif(map_level:tile(row+2,col)==2) then
				if (sizeX*32<=480) then right_left3(0,1,32)
				else
					if row <= sizeX then
						if (row<9 or row>=24)then right_left3(0,1,32)
						elseif (row>8 and row<24)then right_left3(1,1,32)end
					end
				end
			end

		elseif(map_level:tile(row+1,col)==5) then
			if (map_level:tile(row+2,col)<3) then
				if (sizeX*32<=480) then right_left4(0,1,32)
				else
					if row <= sizeX then
						if (row<9 or row>=24)then
							right_left4(0,1,32)
						elseif (row>8 and row<24)then
							right_left4(1,1,32)
						end
					end
				end
			end--col<3
		end
	end--right

	if buttons.start then flag = true end

	if buttons.circle then levels.reset+=1
		if (levels.reset>3) then
			if (ch!=30) then
				ch-=1
				if (ch<1) then ch=1 end
				if #levels>0 then table.remove(levels) end
			end
			if SndEna and Music:playing() then Music:pause() end
			os.message("Wait....no more resets :P")
			levels.reset=0
			if SndEna and Music then Music:play(2) end
		end
		frame=2
		Load_level()
	end

end

function Finish_Level()
	for i=1,sizeY do
		for z=1,sizeX do
			if (map_level:tile(z,i)==2) then return 0 end --Tile 2 Goal
		end
	end
	if cont then cont:stop() end

	if End_Level then End_Level:play(1) end

	os.message("Level "..ch.." is completed\nYour Time: "..math.floor((cont:time()/1000)+1).."s")

	ch += 1

	if ch >29 then levels.mode=1 end

	temp={}
	temp.moves=num_moves
	temp.time=math.floor((cont:time()/1000)+1)
	temp.ch=ch
	table.insert(levels,temp)

	if ch == 30 then
		os.message("Congratulations!!! Easy Mode completed")
	elseif ch > #gamefield then					--Game Finished :P
		os.message("Congratulations!!! Hard Mode completed")
		ch=30
	elseif Save_Load(true,1)==0 then--AutoSave
		Save_Load(true,0)
	end

	if ch==10 then
		if (levels.key==0) then levels={}
			ch=1
			os.message("Ohhh,Sorry!!\n You need find the key to continue to the next levels _9_")
		else levels.key=0 end
	end

	return 1
end

function Time_Over()
	if SndEna and Music:playing() then Music:pause() end
	os.message("The Time is over")

	levels.life-=1
	if (levels.life<1) then
		if ch!=30 then
			ch-=1
			if (ch<1) then ch=1 end
			if #levels>0 then table.remove(levels) end
			os.message("Lost your 3 lifes :(")
		end
		levels.life=3
	end
	if SndEna and Music then Music:play(2) end
	Load_level()
end

function Menu_Home()
	if cont then cont:stop() end

	sel,_save=0,true
	_save_prev=0
	buttons.interval(20,20)
	while true do
		buttons.read()
		if bkg then bkg:blit(0,0) end

		player:blitsprite(120,60+sel,0)
		if _save then
			screen.print(160,82, "Save ->>", 1,ctext,cback)--sel=0
		else
			screen.print(160,82, "<<- Load", 1,ctext,cback)--sel=0
		end
		screen.print(160,122, "Back to Menu", 1,ctext,cback)--sel=40
		screen.print(160,162, "Exit", 1,ctext,cback)--sel=80

		if buttons.down then sel+=40 end
		if buttons.up then sel-=40 end

		if (buttons.right or buttons.left) and sel==0 then
			_save=not _save
		end

		if sel>80 then sel=0 end
		if sel<0 then sel=80 end

		if buttons.cross then

			if sel==0 then									--Save or Load
				if Save_Load(_save)==1 then 
					flag = false
					Load_level()
					break;
				end
			end

			if sel==40 then									--Menu
				levels={}
				levels.key,levels.slots=0,0
				Start_Menu()
				flag = false break;
			end

			if sel==80 then	os.exit() end					--Exit

		end

		if buttons.start or buttons.circle then
			flag = false
			if cont then cont:start() end
			break;
		end
		screen.flip()
	end
end

function Save_Load(save_load,autosave)--false is load...true is save
	if save_load then						--Save

		if #levels<=0 then os.message("0 levels completed") return 0 end

		data_full=""
		for i=1,#levels do
			datas=levels.reset.."#"..levels.life.."#"..levels[i].ch.."#"..levels.mode.."#"..levels[i].time.."#"..levels[i].moves.."#"..levels.key.."#"..levels.slots..","
			data_full=data_full..datas
		end
		if levels.mode==0 then diff="Easy" else diff="Hard" end

		_save_is_true=
		data.save(data_full,"ZSokobanv1","ZSOKOBAN","ZSokoban Homebrew for PSP/PSVita","Mode: "..diff.." Level: "..ch.." Levels Completed: "..#levels.." Lives: "..levels.life.." Resets: "..levels.reset,autosave or 0,levels.slots)
		if _save_is_true == true then return 1 else return 0 end

	else									--Load
		mje = data.load("ZSOKOBAN",0)
		if mje==nil then return 0 end
		levels={}
		for par  in mje:gmatch("%d+#%d+#%d+#%d+#%d+#%d+#%d+#%d+") do
			tmp={}
			levels.reset,levels.life,tmp.ch,levels.mode,tmp.time,tmp.moves,levels.key,levels.slots=par:match("(%d+)#(%d+)#(%d+)#(%d+)#(%d+)#(%d+)#(%d+)#(%d+)")
			table.insert(levels,tmp)
		end
		levels.mode=tonumber(levels.mode)
		levels.life=tonumber(levels.life)
		levels.reset=tonumber(levels.reset)
		levels.key=tonumber(levels.key)
		levels.slots=tonumber(levels.slots)
		ch=tonumber(levels[#levels].ch)
		return 1
	end
end

function Score()

	if levels.mode==0 then
		screen.print(5,5, "Mode:Easy", 0.6,color.green,color.red)
	else
		screen.print(5,5, "Mode:Hard", 0.6,color.green,color.red)
	end
	screen.print(5,20, "Level:"..ch, 0.6,color.green,color.red)
	screen.print(5,35, "Lives:"..levels.life, 0.6,color.green,color.red)
	screen.print(5,50, "Resets:"..levels.reset, 0.6,color.green,color.red)
	screen.print(5,65, "Moves:"..num_moves, 0.6,color.green,color.red)

	local cc=color.green
	if (_time<16) then cc=color.yellow end
	if(_time<11) then cc=color.red end
	screen.print(375,13, "Time: ".._time, 0.8,cc,__ALEFT)

	screen.print(5,240, "0:Reset", 0.6,color.green,color.red)
	screen.print(5,260, "Start:Menu", 0.6,color.green,color.red)
end
