splash.show("images/1LOGO.png")					--splash :P
f=font.load("3force.pgf")
if f then font.setdefault(f) end

buttons.homepopup(0)									--Not HOME
color.loadpalette()
ctext=color.new(255,228,225)
cback=color.new(128,0,0)

dofile("levels/levels.lua")
dofile("functions.lua")

--Resources
w,h=32,32
player = image.load("images/player.png",w,h)			--sprite 32x32
tmp_tiles = image.load("images/tiles.png",w,h)			-- tileset (GBA Graphics)
bkg = image.load("images/bg.png")
Music = sound.load("sounds/zeldarmx.s3m")
Drag = sound.load("sounds/drag.wav",1)
Box_In_Place = sound.load("sounds/box.wav",1)
End_Level = sound.load("sounds/end.wav")

--Vars Globals
x,y,frame=0,0,2											--For player:blitsprite(x,y,frame)
row,col,map_X=-1,-1,0									--For map.blit(map_level,map_X,0)
sizeX,sizeY=-1,-1

flag=false
levels={}
ch,levels.key,levels.mode,levels.slots,levels.life,levels.reset=1,0,0,0,3,0
-------------------------------------------Menu-----------------------------------------------
Start_Menu()
----------------------------------------------------------------------------------------------

--Music in loop
SndEna=true
if Music then
	Music:play(2)
	Music:loop()
end

cont=timer.new()
cont:start()
while true do

	buttons.read()

	if buttons.select then
		if SndEna and Music then Music:stop() SndEna=not SndEna
		elseif Music and not SndEna then Music:play(2) SndEna=not SndEna end
	end

	_time=math.floor( (limit-cont:time())/1000)			--Countdown :P

	if bkg then bkg:blit(0,0) end
	map.blit(map_level,map_X,0)

	if (flag) then Menu_Home()
	else

		if (_time<1) then Time_Over() end

		if (Finish_Level()==1) then	Load_level() end	--Load new level

		Check_Moves()									--Engine Colisions

		player:blitsprite(x,y,frame)
		if levels.key==1 then tmp_tiles:blitsprite(5,70,7) end

		Score()
	end

	if SndEna then screen.print(400,260, "Snd On",0.8,ctext,cback)
	else screen.print(400,260, "Snd Off",0.8,ctext,cback) end

	screen.flip()
end
